#! /bin/sh
#::
#:: Host Publisher Problem Determination Bundling Tool - HPPDTOOL
#::
echo "."
echo "Host Publisher Problem Determination Bundling Tool - v2.0.2"
echo "(C) Copyright IBM Corp. 2000,2001. All Rights Reserved."
echo "."
echo "HPS5720I: This tool will gather and bundle product application files"
echo "          for problem determination purposes.  These files may contain"
echo "          sensitive customer information.  Cancel this tool if you do not "
echo "          wish to disclose any sensitive customer information.  Contact"
echo "          your service representative for more information."
echo "."
if [ "$1" != "/" ]
then 
   echo "."
   echo "   Usage: hppdtool.sh /  [ websphere_appserver_root [ java_root ] ]"
   echo "Examples: hppdtool.sh /"
   echo "        : hppdtool.sh /  /usr/WebSphere/AppServer"
   echo "        : hppdtool.sh /  /                          /usr/java"
   echo "        : hppdtool.sh /  /usr/IBMWebAS              /usr/IBMWebAS/java"
   exit 1
fi

echo "HPS5737I: Make sure WebSphere Application Server is running."
echo "HPS5738I: Press Control-C to cancel this tool."
echo "."

echo "HPS5739R: Press ENTER to continue . . ."
read userResponse


#:STEP_000
#::---------------------------------------------
#:: Setup - 
#::---------------------------------------------

hppdTmp_P2=$2

if [  "$2" = "/" ] 
then 
hppdTmp_P2=""
fi
if [ "$2" = "." ] 
then 
hppdTmp_P2=""
fi

CURRENTDIR=`pwd`
hppdTmp_JDK_ROOT=
hppdTmp_WAS_ROOT=
hppdTmp_WAS_ROOT_BASE=
hppdTmp_TEMPDIR=$CURRNTDIR"/hppdTmp"
hppdTmp_TEMPDIR_MVS="/tmp/hppdTmp"
hppdTmp_IS_MVS="0"
hppdTmp_JDK_JAR_EXE=
hppdTmp_JDK_JAR_EXE_ORG=
hppdTmp_HP_VAR_DIR=
hppdTmp_HP_LPP_DIR=

hppdTmp_HP_ROOT=/var/HostPublisher
hppdTmp_HP_SERVER=$hppdTmp_HP_ROOT/Server
hppdTmp_HP_LOG=$hppdTmp_HP_ROOT/log


#:STEP_001
#::---------------------------------------------
#:: Locate HP Server Root
#::---------------------------------------------
echo "HPS5703I: Checking HP Server root" $hppdTmp_HP_SERVER
if [ ! -d $hppdTmp_HP_SERVER ]
then 
         echo "HPS5704E: Unable to locate HP Server root: " $hppdTmp_HP_SERVER 
	 exit 1
fi
echo "HPS5705I: HP Server root located:" $hppdTmp_HP_SERVER
echo "HPS5722I: HP Server PD/PSI files will be gathered"
echo "."
#::---------------------------------------------


#:---------------------------------------------
#: Locate WAS Server Root ( needed for the JDK ) ( AIX - SunOS - Linux )
#:---------------------------------------------
hppdTmp_OS_NAME=`uname -s`
if [ "$hppdTmp_OS_NAME" = "AIX" ]
then
   hppdTmp_OS_NAME=""
   OSTYPE=aix
   if [ "$hppdTmp_P2" != "" ]
   then 
      hppdTmp_WAS_ROOT=$hppdTmp_P2
      hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
      hppdTmp_JDK_ROOT=/usr/lpp/HostPublisher/common/jdk
      echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
      if [ ! -d  $hppdTmp_WAS_ROOT ]
      then 
         hppdTmp_P2=""
      fi
   fi
   if [ "$hppdTmp_P2" = "" ]
   then
      hppdTmp_WAS_ROOT=/usr/WebSphere/AppServer
      hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
      hppdTmp_JDK_ROOT=/usr/lpp/HostPublisher/common/jdk
      echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
      if [ ! -d  $hppdTmp_WAS_ROOT ]
      then
         hppdTmp_WAS_ROOT=/usr/IBMWebAS
         hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
         hppdTmp_JDK_ROOT=/usr/lpp/HostPublisher/common/jdk
         echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
         if [ ! -d  $hppdTmp_WAS_ROOT ]
         then
            hppdTmp_WAS_ROOT=/usr/lpp/IBMWebAS
            hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
            hppdTmp_JDK_ROOT=/usr/lpp/HostPublisher/common/jdk
            echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
            if [ ! -d  $hppdTmp_WAS_ROOT ]
            then
               echo "HPS5704W: Unable to locate WAS root"
               echo "."
               exit 1
            fi
         fi
      fi         
   fi
fi	 
if [ "$hppdTmp_OS_NAME" = "SunOS" ]
then
   hppdTmp_OS_NAME=""
   OSTYPE=sol
   if [ "$hppdTmp_P2" != "" ]
   then 
      hppdTmp_WAS_ROOT=$hppdTmp_P2
      hppdTmp_HP_LPP_DIR=/opt/HostPublisher
      hppdTmp_JDK_ROOT=/usr/java
      echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
      if [ ! -d  $hppdTmp_WAS_ROOT ]
      then 
         hppdTmp_P2=""
      fi
   fi
   if [ "$hppdTmp_P2" = "" ]
   then
      hppdTmp_WAS_ROOT=/opt/WebSphere/AppServer
      hppdTmp_HP_LPP_DIR=/opt/HostPublisher
      hppdTmp_JDK_ROOT=$hppdTmp_WAS_ROOT/java
      echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
      if [ ! -d  $hppdTmp_WAS_ROOT ]
      then
         hppdTmp_WAS_ROOT=/opt/IBMWebAS
         hppdTmp_HP_LPP_DIR=/opt/HostPublisher
         hppdTmp_JDK_ROOT=/usr/java
         echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
         if [ ! -d  $hppdTmp_WAS_ROOT ]
         then
            hppdTmp_WAS_ROOT=/opt/WebSphere
            hppdTmp_HP_LPP_DIR=/opt/HostPublisher
            hppdTmp_JDK_ROOT=/usr/java
            echo "HPS5703I: Checking WAS root "$hppdTmp_WAS_ROOT
            if [ ! -d  $hppdTmp_WAS_ROOT ]
            then
               echo "HPS5704I: Unable to locate WAS root"
               echo "."
               exit 1
            fi
         fi   
      fi   
   fi
fi   
##:---------------------------------------------

##:---------------------------------------------
## Some other OS? ( OS/390 )
##:---------------------------------------------
if [ "$hppdTmp_OS_NAME" != "" ]
then

   if [ "$hppdTmp_P2" = "" ]
   then
      hppdTmp_WAS_ROOT_BASE=/usr/lpp/WebSphere/AppServer
   else
      hppdTmp_WAS_ROOT_BASE=$hppdTmp_P2
   fi

   OSTYPE=mvs12
   #:: /config only exists WAS 1.2 , config does not exist for 3.02 or 3.5
   hppdTmp_WAS_ROOT=$hppdTmp_WAS_ROOT_BASE/config
   hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
   hppdTmp_HP_VAR_DIR=/var/HostPublisher
   hppdTmp_JDK_ROOT=
   echo "HPS5703I: Checking WAS root:" $hppdTmp_WAS_ROOT
   if [ ! -d  $hppdTmp_WAS_ROOT ]
   then
      OSTYPE=mvs3x
      hppdTmp_WAS_ROOT=$hppdTmp_WAS_ROOT_BASE
      hppdTmp_HP_LPP_DIR=/usr/lpp/HostPublisher
      hppdTmp_HP_VAR_DIR=/var/HostPublisher
      hppdTmp_JDK_ROOT=
      echo "HPS5703I: Checking WAS root:" $hppdTmp_WAS_ROOT
      if [ ! -d  $hppdTmp_WAS_ROOT ]
      then
         echo "HPS5704W: Unable to locate WAS root"
         echo "."
         exit 1
      fi
   fi
fi
##:---------------------------------------------

#::---------------------------------------------
#:: Check the Web server's configuration file for WAS v1.2 location
#::---------------------------------------------
if [ "$OSTYPE" = "mvs12" ]
then
   hppdTmp_WAS_ROOT=`grep "$hppdTmp_WAS_ROOT/lib/libadpter.so" /etc/httpd.conf | grep ServerInit | awk '{print $3}'`
   if [ ! -d $hppdTmp_WAS_ROOT ]
   then
      echo "HPS5740E: Could not locate WebSphere alternate server root directory"
      echo "."
      exit 1
   fi
fi
#::---------------------------------------------

#::---------------------------------------------
#:: Set tmp dir if MVS
#::---------------------------------------------
if [ "$OSTYPE" = "mvs12" ]
then
   hppdTmp_TEMPDIR=$hppdTmp_TEMPDIR_MVS
   hppdTmp_IS_MVS="1"
fi
if [ "$OSTYPE" = "mvs3x" ]
then
   hppdTmp_TEMPDIR=$hppdTmp_TEMPDIR_MVS
   hppdTmp_IS_MVS="1"
fi
#::---------------------------------------------

#:STEP_004_2
#::---------------------------------------------
#:: Locate WAS Server Root
#::---------------------------------------------
echo "HPS5705I: WAS root located: " $hppdTmp_WAS_ROOT
echo "HPS5722I: WAS PD/PSI files will be gathered"
echo "."
#::---------------------------------------------

#:STEP_005
#::---------------------------------------------
#:: Locate JDK root ( java directory )  23, 64-69
#::---------------------------------------------
if [ "$3" = "" ]
then 
   echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
   if [ ! -d  $hppdTmp_JDK_ROOT ]
   then 
      hppdTmp_JDK_ROOT=$hppdTmp_WAS_ROOT"/java"
      echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
      if [ ! -d  $hppdTmp_JDK_ROOT ]
      then 
         hppdTmp_JDK_ROOT=/usr/IBMWebAS/java
         echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
         if [ ! -d  $hppdTmp_JDK_ROOT ]
         then 
            hppdTmp_JDK_ROOT=/usr/WebSphere/AppServer/java
            echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
            if [ ! -d  $hppdTmp_JDK_ROOT ]
            then 
               echo "HPS5704E: Unable to locate JDK root"
               echo "HPS5707E: Specify parameter java_root"
               echo "."
               exit 1
            fi
         fi
      fi
   fi
else
   hppdTmp_JDK_ROOT=$3"/java"
   echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
   if [ ! -d  $hppdTmp_JDK_ROOT ]
   then 
      hppdTmp_JDK_ROOT=$3"/bin"
      echo "HPS5703I: Checking JDK root:" $hppdTmp_JDK_ROOT
      if [ ! -d  $hppdTmp_JDK_ROOT ]
         then 
         echo "HPS5704E: Unable to locate JDK root"
         exit 1
      fi
   fi
fi
#::---------------------------------------------

#:STEP_007
#::---------------------------------------------
#:: Locate JDK ( JAR.exe )
#::---------------------------------------------
   hppdTmp_JDK_JAR_EXE=$hppdTmp_JDK_ROOT"/sh/jar"
   echo "HPS5709I: Checking JAR" $hppdTmp_JDK_JAR_EXE
   if [ ! -f  $hppdTmp_JDK_JAR_EXE ]
   then 
      hppdTmp_JDK_JAR_EXE=$hppdTmp_JDK_ROOT"/bin/jar"
      echo "HPS5709I: Checking JAR" $hppdTmp_JDK_JAR_EXE
      if [ ! -f  $hppdTmp_JDK_JAR_EXE ]
      then 
         hppdTmp_JDK_JAR_EXE=$hppdTmp_WAS_ROOT"/java/bin/jar"
         echo "HPS5709I: Checking JAR" $hppdTmp_JDK_JAR_EXE
         if [ ! -f  $hppdTmp_JDK_JAR_EXE ]
         then 
            hppdTmp_JDK_JAR_EXE=$hppdTmp_JDK_ROOT"/jar"
            echo "HPS5709I: Checking JAR" $hppdTmp_JDK_JAR_EXE
            if [ ! -f  $hppdTmp_JDK_JAR_EXE ]
            then
               hppdTmp_JDK_JAR_EXE="jar"
               echo "HPS5709I: Checking JAR" $hppdTmp_JDK_JAR_EXE
               if [ "$hppdTmp_IS_MVS" = "0" ]
               then
                  echo "HPS5708E: Jar not found"
                  echo "."
                  exit 1
               fi
            fi
         fi
      fi
   fi

echo "HPS5710I: Jar found:" $hppdTmp_JDK_JAR_EXE
echo "."
#::---------------------------------------------

#::---------------------------------------------
#:: Creating temporary directories
#::---------------------------------------------
if [ -d $hppdTmp_TEMPDIR ] 
then
   rm -fr $hppdTmp_TEMPDIR
fi

mkdir $hppdTmp_TEMPDIR
mkdir $hppdTmp_TEMPDIR"/LOG"
mkdir $hppdTmp_TEMPDIR"/VAR"
mkdir $hppdTmp_TEMPDIR"/WAS"
mkdir $hppdTmp_TEMPDIR"/appmanifests"
mkdir $hppdTmp_TEMPDIR"/poolspecs"
mkdir $hppdTmp_TEMPDIR"/beans"
mkdir $hppdTmp_TEMPDIR"/documents"

if [ ! -d $hppdTmp_TEMPDIR"/WAS" ] 
then
   echo "HPS5733E: Unable to create:" $hppdTmp_TEMPDIR"/WAS"
   echo "HPS5734I: Make sure the above directory is in R/W mode"
   exit 1
fi
#::---------------------------------------------

#::---------------------------------------------
echo "HPS5725I: Building the exclusion list"
#::---------------------------------------------
echo HPAdmin                       >hppd.in
echo service_defaults             >>hppd.in
echo adminservice                 >>hppd.in
echo httpservice                  >>hppd.in
echo xmlLegacyPortal.jar          >>hppd.in
echo xmlLegacyGWS.jar             >>hppd.in
echo RIOServlet.jar               >>hppd.in
echo xmlLegacyGateway.application >>hppd.in
echo xmlLegacyPortal.application  >>hppd.in
echo RIOServlet.application       >>hppd.in
echo xmlLegacyGateway             >>hppd.in
echo xmlLegacyPortal              >>hppd.in
echo classes.zip                  >>hppd.in
echo HPubCommon.jar               >>hppd.in
echo RIO.jar                      >>hppd.in
echo nano.zip                     >>hppd.in
echo swingall.jar                 >>hppd.in
echo "."
#::---------------------------------------------

#::---------------------------------------------
#:: Collect the data
#::---------------------------------------------
echo "HPS5726I: Collecting PD/PSI files"
#::---------------------------------------------

#::---------------------------------------------
echo "HPS5727I: Collecting PD/PSI files...HP Server directory list..."
#::---------------------------------------------
ls -lR $hppdTmp_HP_SERVER   >$hppdTmp_TEMPDIR"/DirectoryListingHPServer.txt"
#::---------------------------------------------

#::---------------------------------------------
echo "HPS5728I: Collecting PD/PSI files...HP Server product files..."
#::---------------------------------------------
if [ -d $hppdTmp_HP_SERVER"/production/appmanifests" ]
then 
   cp -r $hppdTmp_HP_SERVER"/production/appmanifests"                               $hppdTmp_TEMPDIR"/appmanifests"  # 1>/dev/null  2>/dev/null
else
   echo "HPS5708W: Missing "$hppdTmp_HP_SERVER"/production/appmanifests"
fi

if [ -d $hppdTmp_HP_SERVER"/production/poolspecs" ]
then 
   cp -r $hppdTmp_HP_SERVER"/production/poolspecs"                                  $hppdTmp_TEMPDIR"/poolspecs"     # 1>/dev/null  2>/dev/null
else
   echo "HPS5708W: Missing "$hppdTmp_HP_SERVER"/production/poolspecs"
fi

if [ -d $hppdTmp_HP_SERVER"/production/beans" ]
then 
   cp -r $hppdTmp_HP_SERVER"/production/beans"                                      $hppdTmp_TEMPDIR"/beans"         # 1>/dev/null  2>/dev/null
else
   echo "HPS5708W: Missing "$hppdTmp_HP_SERVER"/production/beans"
fi

if [ -d $hppdTmp_HP_SERVER"/production/documents" ]
then 
   cp -r $hppdTmp_HP_SERVER"/production/documents"                                  $hppdTmp_TEMPDIR"/documents"     # 1>/dev/null  2>/dev/null
else
   echo "HPS5708W: Missing "$hppdTmp_HP_SERVER"/production/documents"
fi

if [ -f $hppdTmp_HP_SERVER"/production/documents/xmlLegacyPortal/hPubPortalData.xml" ]
then
   cp    $hppdTmp_HP_SERVER"/production/documents/xmlLegacyPortal/hPubPortalData.xml" $hppdTmp_TEMPDIR               # 1>/dev/null  2>/dev/null
fi

if [ -f $hppdTmp_HP_LPP_DIR"/Server/product.xml" ]
then
   cp $hppdTmp_HP_LPP_DIR"/Server/product.xml" $hppdTmp_TEMPDIR 1>/dev/null  2>/dev/null
fi

cp $hppdTmp_HP_SERVER"/HostPubWASConfig.xml"     $hppdTmp_TEMPDIR        1>/dev/null  2>/dev/null
cp -r $hppdTmp_HP_SERVER"/*fixdata*"             $hppdTmp_TEMPDIR        1>/dev/null  2>/dev/null
cp -r $hppdTmp_HP_LOG                            $hppdTmp_TEMPDIR"/LOG"  1>/dev/null  2>/dev/null
cp $hppdTmp_HP_SERVER"/server.properties"        $hppdTmp_TEMPDIR        1>/dev/null  2>/dev/null

#::---------------------------------------------
echo ""
echo "HPS5727I: Collecting PD/PSI files...WAS directory list..."
#::---------------------------------------------
ls -lR $hppdTmp_WAS_ROOT >$hppdTmp_TEMPDIR"/DirectoryListingWAS.txt"
#::---------------------------------------------

#::---------------------------------------------
#:: Gather WAS files - Gather WebSphere logs and 
#:: files, depending on level of WebSphere. Look 
#:: for the "hosts" as a flag for v3
#::---------------------------------------------

#::---------------------------------------------
# Gather WebSphere logs and files, depending on level of WebSphere. Look for the "hosts"
# directory under AppServer for V3
#::---------------------------------------------
if [ -d $hppdTmp_WAS_ROOT"/hosts" ]
then
   #:STEP_WAS_VERSION_3
   #::---------------------------------------------
   #:: We can't get the active configuration from a batch file, so the best we can do is
   #:: grab the configuration XML file under the Host Publisher directory. Log files are all
   #:: under HostPub/log, which we've already grabbed.
   #::---------------------------------------------
   echo "HPS5728I: Collecting PD/PSI files...WAS product files..."
   #::---------------------------------------------
   cp $hppdTmp_WAS_ROOT"/bin/admin.config" $hppdTmp_TEMPDIR"/WAS"   1>/dev/null  2>/dev/null
   cp $hppdTmp_HP_LPP_DIR"/HostPubWASConfig.xml" $hppdTmp_TEMPDIR   1>/dev/null  2>/dev/null
   #::---------------------------------------------

   #::---------------------------------------------
   # Rewrite hostPubWAS.sh to perform an export of WAS configuration
   #::---------------------------------------------
   cd $hppdTmp_HP_LPP_DIR
   if [ -f HostPubWAS.sh ]
   then
      sed 's/-import/-export/g' HostPubWAS.sh > HostPubWASexp.sh
      chmod +x HostPubWASexp.sh
      ./HostPubWASexp.sh $hppdTmp_TEMPDIR"/WAS/xmlConfig.out" > /dev/null
   else
      echo "HPS5708W: Missing "$hppdTmp_HP_LPP_DIR"/HostPubWAS.sh"
      echo "HPS5741W: Unable to export WAS configuration"
   fi
   cd $CURRENTDIR > /dev/null
   #::---------------------------------------------

   if [ -d $hppdTmp_WAS_ROOT"/logs" ]
   then 
      #::---------------------------------------------
      echo "HPS5728I: Collecting PD/PSI files...WAS logs..."
      #::---------------------------------------------
      cp -r $hppdTmp_WAS_ROOT"/logs"  $hppdTmp_TEMPDIR"/WAS" 1>/dev/null  2>/dev/null
      #::---------------------------------------------
   fi

   if [ -d $hppdTmp_WAS_ROOT"/properties" ]
   then 
      #::---------------------------------------------
      echo "HPS5728I: Collecting PD/PSI files...WAS product files..."
      #::---------------------------------------------
      cp -r $hppdTmp_WAS_ROOT"/properties"  $hppdTmp_TEMPDIR"/WAS" 1>/dev/null  2>/dev/null
      #::---------------------------------------------
   fi
else
   #::---------------------------------------------
   echo "HPS5728I: Collecting PD/PSI files...WAS logs..."
   #::---------------------------------------------
   cp -r $hppdTmp_WAS_ROOT"/logs"  $hppdTmp_TEMPDIR"/WAS" 1>/dev/null  2>/dev/null
   #::---------------------------------------------

   #::---------------------------------------------
   echo "HPS5728I: Collecting PD/PSI files...WAS product files..."
   #::---------------------------------------------
   cp -r $hppdTmp_WAS_ROOT"/properties"  $hppdTmp_TEMPDIR"/WAS" 1>/dev/null  2>/dev/null
   #::---------------------------------------------
fi
#::---------------------------------------------

#::---------------------------------------------
# now delete unwanted files - use the exclusion list
#::---------------------------------------------
cd $hppdTmp_TEMPDIR
for i in `cat $CURRENTDIR/hppd.in`
do
	find . -name $i -exec rm -r {} ";" 2> /dev/null
done
cd $CURRENTDIR
rm hppd.in
#::---------------------------------------------

#::---------------------------------------------
#:: Create the PD/PSI Jar file
#::---------------------------------------------
echo "HPS5729I: Creating PD/PSI Jar file..."
cd $CURRENTDIR
$hppdTmp_JDK_JAR_EXE cMf ./hppd.$OSTYPE.jar $hppdTmp_TEMPDIR
rm -fr $hppdTmp_TEMPDIR
#::---------------------------------------------

#::---------------------------------------------
#:: Done
#::---------------------------------------------
echo "."
echo "HPS5730I: DONE - ./hppd."$OSTYPE".jar file has been created. Please"
echo "          send this file to IBM Service when requested."
echo "."
echo "."
#::---------------------------------------------

exit 0

